<!DOCTYPE html>
<html lang="zxx">

<head>
  <meta charset="utf-8">
  <title>MDEF | Andrea Bertran_Embedded programming</title>
  <link rel="icon" type="image/png" href="images/favicomatic/favicon-32x32.png" sizes="32x32" />
  <!-- mobile responsive meta -->
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">

  <!-- ** Plugins Needed for the Project ** -->
  <!-- Bootstrap -->
  <link rel="stylesheet" href="plugins/bootstrap/bootstrap.min.css">
  <link rel="stylesheet" href="plugins/themify/css/themify-icons.css">
  <link rel="stylesheet" href="plugins/counto/animate.css">
  <link rel="stylesheet" href="plugins/aos/aos.css">
  <link rel="stylesheet" href="plugins/owl-carousel/owl.carousel.min.css">
  <link rel="stylesheet" href="plugins/owl-carousel/owl.theme.default.min.css">
  <link rel="stylesheet" href="plugins/magnific-popup/magnific-popup.css">
  <link rel="stylesheet" href="plugins/animated-text/animated-text.css">

  <!-- Main Stylesheet -->
  <link href="css/style.css" rel="stylesheet">

</head>

<body>

<!-- Navigation Start -->
<!-- Header Start -->

<nav class="navbar navbar-expand-lg  main-nav " id="navbar">
    <div class="container">
	  <a class="navbar-brand" href="index.html">
	  	<img src="images/logo_2.png" alt="Image" style="width:170px"; class="img-fluid">
	  </a>


    <button class="navbar-toggler collapsed" type="button" data-toggle="collapse" data-target="#navbarsExample09" aria-controls="navbarsExample09" aria-expanded="false" aria-label="Toggle navigation">
		<span class="ti-align-justify"></span>
	  </button>

  	  <div class="collapse navbar-collapse" id="navbarsExample09">
			<ul class="navbar-nav ml-auto">

      <li class="nav-item dropdown">
          <a class="nav-link dropdown-toggle" href="#" id="dropdown01" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">Info</a>
          <ul class="dropdown-menu" aria-labelledby="dropdown01">
            <li><a class="dropdown-item" href="about-me.html">About me</a></li>
            <li><a class="dropdown-item" href="contact.html">Contact</a></li>
            <li><a class="dropdown-item" href="https://www.dropbox.com/home/Portfolio?preview=2019.01_Portfolio+Andrea+Bertran.pdf" target="_blank" >Portfolio</a></li>
          </ul>
        </li>

        <li class="nav-item dropdown">
          <a class="nav-link dropdown-toggle" href="#" id="dropdown02" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">MDEF</a>
          <ul class="dropdown-menu" aria-labelledby="dropdown02">
            <li><a class="dropdown-item" href="term1.html">Term 1</a></li>
            <li><a class="dropdown-item" href="term2.html">Term 2</a></li>
            <li><a class="dropdown-item" href="term3.html">Term 3</a></li>
            <li><a class="dropdown-item" href="masterproject.html">Master's project</a></li>
          </ul>
        </li>

      </ul>
      </div>
  </div>
</nav>

<!-- Header Close -->


<!-- Body Open -->
<section class="page-title section pb-0">
  <div class="container">
    <div class="row">
      <div class="col-lg-12">

        <div class="text-left">
          <h2 class="mb-0 text-lg">'Embedded programming'</h2>
          <span class="date text-sm">03.25.2020</span>
        </div>
      </div>
      </div>
    </div>
  </div>
 </div>
</section>

<section class="section portfolio-single">
	<div class="container">
		<div class="row justify-content-center">
			<div class="col-lg-12">
				<div class="project-info" align="justify">
          <h4>Reading a datasheet</h4>
          <span style="display:block; height: 20px;"></span>
          <p>
            I decided to read more about the microcontroller that my board has: ATmega328 microcontroller with Optiboot (UNO) Bootloader -   <a target="_blank" href="http://ww1.microchip.com/downloads/en/DeviceDoc/ATmega48A-PA-88A-PA-168A-PA-328-P-DS-DS40002061A.pdf"><i>Datasheet</i></a>. But before reading the datasheet I wanted to understand what a Optiboot Bootloader means. So I searched for it and found that the bootloader is a section of the program memory that runs before the main code (or first intruction) runs. It is used to setup a microcontroller or to allow it to update the main program's code.
            <br><br>
            In the case of the ATmega328p. This microcontroller has specifically a portion of its memory for bootlading code. When on power, this microcontroller waits a short time while paying attention to the pins. In case it doesn't receive any information, then the processor loads the "user program" section to load whatever is already in the memory, for example a sketch.
            <br><br>
            <a class="image">
            <img src="images/Term_02/Embedded programming/mc.JPG" alt="" style="width:512px" class="img-fluid"></img>
            <img src="images/Term_02/Embedded programming/mc_2.JPG" align="right" alt="" style="width:578px" class="img-fluid"></img></a>
            <br><br>
            This is an 8-bit microcontroller that has 32 registers for which 23 are programmable I/O lines and a memory size of 32KBytes of Flash, 1KBytes of EEPROM (Electrically Erasable Programmable Read Only Memory) which according to what I understood this refers back to the storing of data in memory, so if the electric supply is removed the microcontroller can store the data and then provide results when reconnecting it to another electric supply. And 2KBytes of Ram.

            <br><br>

            It operates with a 3.3V to 5.5V supply, although we use 5V normally.

            All the I/O ports have "pull-up resistors with a supply-voltage invariant resistance" for newbies like me not to burn it. Something else that I found interesting is that the ports are bi-directional. From what I understood, it means that the direction of a port can be changed through the use of SBI / CBI instructions. Which refer to assembler instructions that work specifically with registers.

            <br><br><br><br>

            <h4>Arduino & setting IDE</h4>
            <span style="display:block; height: 20px;"></span>
            Even though we've used Arduino in class before, it has been a long time since I don't use it. At the beginning I had a hard time uploading the file to my board. I knew it wasn't something related to the code as I opened and exercise file. Then I realized it was because the last time I used the software I changed the board. I own a <a target="_blank" href="https://www.sparkfun.com/products/13975"><i>SparkFun RedBoard</i></a>, and to find which board I needed for the IDE. I went to the the webpage and found it, I can use "Arduino UNO" from the board menu (Tools/Board:Arduino Uno) to upload code.
            <br><br>
            For the first example - "Analog write". I didn't feel like taking long. So I just plugged everything together, upload the file and worked fine. Checking the Led was connected to pin 9 as instructed in the example file, and connecting it to the 5V power.

            <br><br>
            <video width="556px" height="" controls>
              <source src="images/Term_02/Embedded programming/AW_WithDelay_Fade.mp4" type="video/mp4">
                <source src="movie.ogg" type="video/ogg">
            </video>
            <a class="image">
            <img src="images/Term_02/Embedded programming/AW_WithDelay_Fade.JPG" align="right" alt="" style="width:533px" class="img-fluid"></img></a>
            <br><br>

            For the second example - "Digital write". I wanted to add more leds and put a delay between them, so it could be more of a rainbow (Why a rainbow? To light up our lives during COVID19 quarantine. Jk, I don't have many LEDS at home). I found a few examples on the internet and followed this <a target="_blank" href="https://www.youtube.com/watch?v=c4M-GAS4cWE"><i>tutorial</i></a>. First I needed to connect the leds to a pin so I used the second pin to the twelfth. After connecting them and making sure their catode tip was connected to my ground. I  uploaded the file. Inside it, I defined two for functions. One to light up the leds from left to right and other for the opposite, so the leds would make a "wave".

            <br><br>
            <video width="556px" height="" controls>
              <source src="images/Term_02/Embedded programming/KnightRider.mp4" type="video/mp4">
                <source src="movie.ogg" type="video/ogg">
            </video>
            <a class="image">
            <img src="images/Term_02/Embedded programming/KnightRider.JPG" align="right" alt="" style="width:533px" class="img-fluid"></img></a>
            <br><br>

            Finally for the third example, I wanted to "Blink without delay" but not only for one led. Maybe adjust two with different times. The led connected to number 13, worked like that (w/o delay). I tried to change the code to see if it was possible to set another interval for the led connected to number 8. I tried a few times but couldn't make it. So in the end, I used delay for the 2nd led. Setting it to every 1000 milliseconds (half the time the "Blink without delay led" was supposed to turn on). I have to say that I didn't spend a long time looking for the right way, the presentation of Design Dialogues was taking me a long time and I wanted to finish it first. So I left the code like this, I'll return to it next week or for another assignment.

            <br><br>
            <video width="556px" height="" controls>
              <source src="images/Term_02/Embedded programming/DW_BlinkWithoutDelay_and_Delay.mp4" type="video/mp4">
                <source src="movie.ogg" type="video/ogg">
            </video>
            <a class="image">
            <img src="images/Term_02/Embedded programming/DW_BlinkWithoutDelay_and_Delay.JPG" align="right" alt="" style="width:533px" class="img-fluid"></img></a>

            <br><br>
            Files: <ul>
              <li><a href="images/Term_02/Embedded programming/WithDelay_Fade.rar" download=""> <i>Analog Write</i></a></li>
              <li><a href="images/Term_02/Embedded programming/KnightRider.rar" download=""> <i>Digital Write</i></a></li>
              <li><a href="images/Term_02/Embedded programming/BlinkWithoutDelay_and_Delay.rar" download=""> <i>Blink without delay and delay</i></a></li>
            </ul>

            <br><br>
            <h4>Arduino libraries</h4>
            <span style="display:block; height: 20px;"></span>
            Libraries add extra functions for the use of sketches. They basically contain extra definitions and anyone can create their own. They consist on two files, one with the extension ".h" - which contains definitions for the library as commands/functions and other variables. And other with ".cpp" - which has the code used to communicate and conect with the Driver. This file has complex code written in C. We normally won't read it, but we access to it through commands as "void - moveTo", "boolean - run", "float - maxSpeed", etc...
            <br><br>
            For this exercise, I wanted to use my LCD, so I needed the "LiquidCrystal.h" library which has commands like "lcd.begin", "lcd.clear", etc...
            <br><br>
            I mostly followed this <a target="_blank" href="https://learn.sparkfun.com/tutorials/basic-character-lcd-hookup-guide"><i>tutorial</i></a>, to understand the pins, where to connect them and what I could do with the code.
            <br><br>
            In brief, first I needed o connect te pins the the corresponding in the breadboard. Ground to ground, power to power, for the contrast adjust I added a potentiometer with its own legs connected to power and ground correspondingly. The data pins and backlight power and ground. After this I defined the setup and for it clear the screen and connect the pins from where I was sending the information. After the setup, I added a loop for displaying the message.

            Here, I had a bit of a hard time because I wanted to show the message and then move it all to the left but the screen cut the text and didn't show it all, even if it started moving as desired.

            In the end, I broke down the phrase into various functions and adding a delay between them to allow the screen to clear the previous information for then showing the next message.

            <br><br>
            <a class="image">
            <img src="images/Term_02/Embedded programming/LCD_Pinout.png" alt="" style="width:610px" class="img-fluid"></img>
            <img src="images/Term_02/Embedded programming/Library.JPG" alt="" style="width:480px" align="right" class="img-fluid"></img></a>
            <br><br>
            <video width="1110px" height="" controls>
              <source src="images/Term_02/Embedded programming/LCD.mp4" type="video/mp4">
                <source src="movie.ogg" type="video/ogg">
            </video>
            <br><br>
            File: <ul>
              <li><a href="images/Term_02/Embedded programming/LiquidCrystal.rar" download=""> <i>LCD</i></a></li>
            </ul>

            <br><br>
            <h4>Platformio</h4>
            <span style="display:block; height: 20px;"></span>
            I wanted to use the potentiometer again and do something different so I looked for an example in Arduino and chose "Bar Graph." I tried to change the code in order to use registers, but... I couldn't.
            So, in the end I just created the folder using Platformio (after downloading the package and adding it to Atom), imported the arduino library, understood the reason why the code was written that way and changed the parameters needed to make my own board work. Here, I had to define setup first and I used a for function, instructing it to read all from the 2 ledPin to the 9th. Then, for the loop function, I needed to read the sensor or in this case the potentiometer first and define when it was high or low so according to the number of leds it could start to light up when changing the value through the potentiometer. Finally and if funtion to make sure that if the potentiometer reading was high, it could leave the leds on and when lowering dow, it could turn them off.
            <br><br>
            <video width="556px" height="" controls>
              <source src="images/Term_02/Embedded programming/BarGraph.mp4" type="video/mp4">
                <source src="movie.ogg" type="video/ogg">
            </video>
            <a class="image">
            <img src="images/Term_02/Embedded programming/Platformio.JPG" align="right" alt="" style="width:533px" class="img-fluid"></img></a>
            <br><br>
            File: <ul>
              <li><a href="images/Term_02/Embedded programming/Sparkfun_Platformio.rar" download=""> <i>Bar Graph</i></a></li>
            </ul>


          </p>


<!-- Body Close -->
  <br></br>

        <div class="mt-5">
					<a href="2020.24_Design Dialogues 2.html" class="image">
          <img src="images/Izq.png" alt="" style="width:12px" class="img-fluid"></a>

					<a href="2020.04.01_Input devices.html" class="image">
          <img src="images/Dcha.png" alt="" style="width:12px" align="right" class="img-fluid"></a>
				</div>

			</div>
		</div>
	</div>
</section>

<!-- Footer start -->
<section class="footer">
	<div class="container">
		<div class="row ">
			<div class="col-lg-6">
        <p class="mb-0"> Email. <a href="mailto:andrea.bertran@students.iaac.net"> <b>andrea.bertran@students.iaac.net</b> </a></p>
        ---
        <p class="mb-0">Copyrights © 2019. Designed & Developed by <a target="_blank" href="https://themefisher.com/"> <b>Themefisher</b> </a></p>
        <p class="mb-0">Copyrights © 2019. Owned and modified by <a target="_blank" href="https://fablabbcn.org/" > <b>Iaac-FablabBarcelona</b> </a></p>
			</div>
			<div class="col-lg-6">
				<div class="widget footer-widget text-lg-right mt-5 mt-lg-0">
					<ul class="list-inline mb-0">
						<li class="list-inline-item"><a href="https://www.instagram.com/ablahh/" target="_blank"><i class="ti-instagram mr-3"></i></a>
						</li>
						<li class="list-inline-item"><a href="https://twitter.com/andreablahh" target="_blank"><i class="ti-twitter mr-3"></i></a>
						</li>
            <li class="list-inline-item"><a href="https://ablahh.tumblr.com/" target="_blank"><i class="ti-tumblr mr-3"></i></a>
						</li>
						<li class="list-inline-item"><a href="https://www.linkedin.com/in/andrea-bertran-l%C3%B3pez-57ba43126/" target="_blank"><i class="ti-linkedin mr-3"></i></a></li>
					</ul>
				</div>
			</div>
		</div>
	</div>
</section>
<!-- jQuery -->
<script src="plugins/jQuery/jquery.min.js"></script>
<!-- Bootstrap JS -->
<script src="plugins/bootstrap/bootstrap.min.js"></script>
<script src="plugins/aos/aos.js"></script>
<script src="plugins/owl-carousel/owl.carousel.min.js"></script>
<script src="plugins/shuffle/shuffle.min.js"></script>
<script src="plugins/magnific-popup/jquery.magnific-popup.min.js"></script>
<script src="plugins/animated-text/animated-text.js"></script>
<script src="plugins/counto/apear.js"></script>
<script src="plugins/counto/counTo.js"></script>

 <!-- Google Map -->
<script src="plugins/google-map/map.js"></script>
<script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyAkeLMlsiwzp6b3Gnaxd86lvakimwGA6UA&callback=initMap"></script>
<!-- Main Script -->
<script src="js/script.js"></script>

</html>
